package edu.mermet.tp8;

import java.awt.event.ActionEvent;
import java.util.ResourceBundle;

import javax.swing.AbstractAction;

public abstract class ActionFonctionnalite extends AbstractAction {

	Application app;
	String nomFonctionnalite;
	// On suppose que les niveaux des fonctionnalités sont des puissances de deux
	int niveauFonc;
	int niveauMax;
	
	public ActionFonctionnalite(String nomFonc, Application a) {
		super(nomFonc);
		app = a;
		nomFonctionnalite = nomFonc;
		ResourceBundle b = ResourceBundle.getBundle("fonctionnalites");
		niveauFonc = Integer.parseInt(b.getString(nomFonc.replace(' ', '_')));
		niveauMax = niveauFonc * 2 * 2;
	}
	
	public void xp() {
		float niveau = Preferences.getInstance().getNiveau();
		if(niveau < niveauMax) {
			Preferences.getInstance().setNiveau( niveau + niveauFonc / 10. <= niveauMax ?
					niveau + (float) niveauFonc / 10 : (float) niveauMax);
			Preferences.getInstance().persist();
			app.refreshMenuMode();
		}
	}

}
